#ifndef _LCD

#define _LCD

/****************************************************/
//If you compile the library by Turbo C, you must define _TURBOC.
//#define _TURBOC

#ifdef _TURBOC

#define _inp    inp
#define _outp   outp  

#endif
/*****************************************************/


/*****************************************************
* Before reading the program, you have to know that: *
*
* G = Graphic
* T = Text
* RW = Read / Write
* SW = Show
* CG = Code Generator
* STA = Status
* ADDR = Address
* PTR = Pointer
* SCRN = Screen
* Clr = Clear
* V = Vertical
* H = Horizontal
******************************************************/
typedef unsigned int  uint;
typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned long DWORD;
typedef short         int16;
typedef unsigned short uint16;
typedef long          int32;
typedef unsigned long uint32;


#define lcd_bright LCDBright
#define show_lcd_page LCDSetToPage


//Functions Return: If success -> return 0, else if fail -->return nonzero.
#ifdef __cplusplus
extern "C" {
#endif

/* ********************* */
/* * * * Initial.C * * * */
/* ********************* */
int InitLCD(void);
int ClrScrn(void);  //Clear GraphicSW_Page and TextSW_Page.
void CloseLCD(void);

/***********************   Functions    ********************************/

int Pixel(int X,int Y, int Color);
int VLine(int X, int Y1, int Y2, int Color);
int HLine(int X1, int X2, int Y, int Color);
int Line(int X1,int Y1,int X2,int Y2,int Color);
int DrawText(int X, int Y, unsigned char *Text);
int Box(int X1, int Y1, int X2, int Y2, int Color);

int SetCursorLine(int Line);
int SetCursorAt(int X, int Y);
void GetCursorAt(int *X, int *Y);
int UnderLine(int X, int Y, int Len,int Color);
int TextOutAt(int X, int Y, char *Str);
int LcdPrintfAt(int X, int Y, char *FormatStr, ...);

int lamp (int X, int Y,int Color);
void LCDBright (int bright);
int LCDSetToPage (int Page);
int GetLCDPage(void);
int IntOutAt(int X, int Y, int Len, int32 Value );
int RealOutAt(int X, int Y, int Len,int Decimal ,float Value );
int BmpShowAt(int X, int Y, char *fname ,int Color);
int TextOutAt_len(int X, int Y, char *Str,int len);

#ifdef __cplusplus
}
#endif

#endif
